#ifndef _npe_SDL_events_h_
#define _npe_SDL_events_h_

enum {
	SDL_KEYDOWN,
	SDL_KEYUP,
	SDL_JOYAXISMOTION,
	SDL_JOYBUTTONDOWN,
	SDL_JOYBUTTONUP,
	SDL_MOUSEBUTTONDOWN,
	SDL_MOUSEBUTTONUP,
	SDL_MOUSEWHEEL,
	SDL_MOUSEMOTION,
	SDL_QUIT,
	SDL_DROPFILE,
	SDL_TEXTINPUT,
	SDL_WINDOWEVENT,
	SDL_WINDOWEVENT_HIDDEN,
	SDL_WINDOWEVENT_SHOWN,
	SDL_WINDOWEVENT_MINIMIZED,
	SDL_WINDOWEVENT_FOCUS_LOST,
	SDL_WINDOWEVENT_EXPOSED,
	SDL_WINDOWEVENT_SIZE_CHANGED,
	SDL_WINDOWEVENT_RESIZED = SDL_WINDOWEVENT_SIZE_CHANGED, /* FIXME I don't even fucking know... */

	SDL_TEXTINPUTEVENT_TEXT_SIZE = UTFmax,

	SDL_ADDEVENT = 0,
	SDL_PEEKEVENT,
	SDL_GETEVENT,
};

typedef struct SDL_Event SDL_Event;
typedef int SDL_eventaction;

struct SDL_Event {
	int type;
	struct {
		int event;
	}window;
	struct {
		struct {
			SDL_Scancode scancode;
			SDL_Keycode sym;
		}keysym;
		int repeat;
	}key;
	struct {
		int x, y;
		int button;
	}button;
	struct {
		int button;
		int state;
	}cbutton;
	struct {
		int button;
	}jbutton;
	struct {
		int value;
		int axis;
	}jaxis;
	struct {
		int x, y;
	}motion;
	struct {
		char text[SDL_TEXTINPUTEVENT_TEXT_SIZE+1];
	}text;
	struct {
		int x, y;
	}wheel;
	struct {
		char *file;
	}drop;
};

int SDL_EventState(Uint32, int);
int SDL_PollEvent(SDL_Event *event);
int SDL_PushEvent(SDL_Event *event);
int SDL_WaitEvent(SDL_Event *event);
int SDL_RegisterEvents(int);
int SDL_PeepEvents(SDL_Event *events, int numevents, SDL_eventaction action, Uint32 minType, Uint32 maxType);

#endif
