#ifndef _npe_SDL_keycode_h_
#define _npe_SDL_keycode_h_

#include <keyboard.h>

typedef int SDL_Keycode;
typedef int SDL_Keymod;

enum {
	SDLK_a = 'a',
	SDLK_b,
	SDLK_c,
	SDLK_d,
	SDLK_e,
	SDLK_f,
	SDLK_g,
	SDLK_h,
	SDLK_i,
	SDLK_j,
	SDLK_k,
	SDLK_l,
	SDLK_m,
	SDLK_n,
	SDLK_o,
	SDLK_p,
	SDLK_q,
	SDLK_r,
	SDLK_s,
	SDLK_t,
	SDLK_u,
	SDLK_v,
	SDLK_w,
	SDLK_x,
	SDLK_y,
	SDLK_z,
	SDLK_0 = '0',
	SDLK_1,
	SDLK_2,
	SDLK_3,
	SDLK_4,
	SDLK_5,
	SDLK_6,
	SDLK_7,
	SDLK_8,
	SDLK_9,
	SDLK_DELETE = Kdel,
	SDLK_RETURN = '\n',
	SDLK_ESCAPE = Kesc,
	SDLK_LESS = '<',
	SDLK_SPACE = ' ',
	SDLK_TAB = '\t',
	SDLK_LEFT = Kleft,
	SDLK_RIGHT = Kright,
	SDLK_DOWN = Kdown,
	SDLK_UP = Kup,
	SDLK_F1 = KF|1,
	SDLK_F2,
	SDLK_F3,
	SDLK_F4,
	SDLK_F5,
	SDLK_F6,
	SDLK_F7,
	SDLK_F8,
	SDLK_F9,
	SDLK_F10,
	SDLK_F11,
	SDLK_F12,

	SDLK_INSERT = Kins,
	SDLK_PAGEUP = Kpgup,
	SDLK_PAGEDOWN = Kpgdown,
	SDLK_HOME = Khome,
	SDLK_END = Kend,
	SDLK_BACKSPACE = Kbs,
	SDLK_MINUS = '-',
	SDLK_PLUS = '+',
	SDLK_EQUALS = '=',
	SDLK_UNDERSCORE = '_',

	SDLK_LALT = Kalt,
	SDLK_RALT = Kaltgr, /* FIXME what about keyboards without it? */
	/* FIXME no distinction */
	SDLK_LSHIFT = Kshift,
	SDLK_RSHIFT = SDLK_LSHIFT,
	SDLK_LCTRL = Kctl,
	SDLK_RCTRL = '>', /* FIXME this is a hack */

	/* FIXME not bound to anything */
	SDLK_UNKNOWN = -99999,
	SDLK_CAPSLOCK,
	SDLK_KP_ENTER,
	SDLK_AC_BACK,

	/* FIXME no distinction */
	KMOD_LSHIFT = 1<<0,
	KMOD_RSHIFT = KMOD_LSHIFT,
	KMOD_LCTRL = 1<<1,
	KMOD_RCTRL = KMOD_LCTRL,
	KMOD_LALT = 1<<2,
	KMOD_RALT = 1<<3,
	KMOD_LGUI = 1<<4,
	KMOD_RGUI = KMOD_LGUI,
	KMOD_CAPS = 1<<5,

	KMOD_SHIFT = KMOD_LSHIFT|KMOD_RSHIFT,
	KMOD_CTRL = KMOD_LCTRL|KMOD_RCTRL,
	KMOD_ALT = KMOD_LALT|KMOD_RALT,
	KMOD_GUI = KMOD_LGUI|KMOD_RGUI,
};

#endif
